# 加餐五 | 听一听小争哥对Google工程师文化的解读

在技术圈里，我们经常听到“工程师文化”这个词。很多公司的HR、管理层都热衷于研究Google、Facebook、Netflix等大公司的文化，希望能打造成和它们一样优秀的工程师文化。

过去几年，好几位朋友也问过我，怎么才能打造跟Google一样的工程师文化？实际上回答这个问题之前，我们先要搞清楚，到底什么是工程师文化，Google的工程师文化是什么。今天，我就针对这三个问题，聊一聊我对Google工程师文化的理解。

话不多说，让我们正式开始今天的内容吧！

## 什么是工程师文化？

我觉得，很多人对“工程师文化”这个词有误解，以为它是一个描述词，甚至是褒义词，表示工程师占主导的公司文化。实际上，我觉得，“工程师文化”是一个名词，你可以类比饮食文化、穿衣文化来理解，它指的是技术团队的价值观（这个团队最看重什么，比如效率、质量等等），更直白点讲就是做事风格。

每个技术团队都有自己的工程师文化，不管这种文化有没有被书面或者口头上表达出来。不过，工程师文化包含很多方面，就像人的价值观一样，有爱情观、金钱观、人生观等等。所以，它很难用一句话来总结。但因为某些公司的工程师文化中的某些方面比较突出、比较有个性，我们常用这些特殊点来“以偏概全”地代指，比如某些公司的工程师文化是“狼性文化”“奋斗文化”“996文化”“PPT文化”“养老院文化”等等。

工程师文化会潜移默化地影响团队中的每个人，不认同这种文化的人会选择离开，最终留下的人价值观都会趋同。形成好的工程师文化的主要目的是，公司希望通过文化而非管理和流程，来驱动团队中的每个人，步调一致地工作和交流。

## Google的工程师文化是什么？

为什么很多公司都要学习Google的工程师文化呢？我觉得主要原因是，Google凝聚了很多优秀的人才，并且往外输出了很多优秀的技术和产品，侧面上证明了Google工程师文化的优秀，所以，很多公司也希望能借鉴Google的工程师文化，把自己的技术团队也打造成像Google的技术团队那样，执行力强、工作效率高、创新能力强的优秀团队。

目标很明确，就是要打造优秀的技术团队。但要达成这样的目标，首先要理解Google的工程师文化是什么样的。

实际上，不同的人对Google工程师文化的理解是不同的。有些人把Google的工程师文化理解为，重视代码质量、重视效率、工匠精神、技术驱动、扁平化管理等等，还有些人甚至理解为，昂贵的电脑和座椅、按摩和报销等各种福利、少开会不加班、免费一日三餐、无限供应的零食等等。

当然，上面提到的这些在Google都是真实存在的。不过，这都是表象。如果只是学这些表面上的东西，“抄不到”Google工程师文化的本质和精髓，我们也就很难打造成像Google一样的工程师文化了。**那Google工程师文化的本质是什么呢？我觉得，如果用一句话来描述的话，那就应该是“尖子生”文化。**

这里所说的“尖子生”，跟我们上学时候的“尖子生”是一个意思。不知道你学校里有没有“尖子生班”？或者你有没有在“尖子生班”待过？一般来说，“尖子生班”的同学在各个方面都表现得非常优秀，而且，这种优秀不仅仅体现在学习上面，其他非学习相关的活动也表现得很好。最值得一提的是，这种优秀是自发形成的，不需要老师的督促和刻意的培养。

类比到Google的工程师文化，Google可以算作工程师中的“尖子生班”。我们知道，Google用人条件很苛刻、招聘要求很高，身边的同事个个都具有光鲜的背景和履历，称为”尖子生“不足为过。这些最顶尖的工程师聚集在一起，不出意外的情况下，稍加引导，就能形成优秀的工程师文化，高产出、高效率、高创新是必然的。至于前面提到的其他方面，比如重视代码质量、工匠精神、重视效率等等，更是不在话下。

## 如何打造像Google一样的工程师文化？

表面上的东西很容易“借鉴”，比如为员工购买昂贵的电脑和座椅，但要想打造像Google一样的工程师文化，本质上还是要在”人“上下功夫。招聘最优秀的人才，给足钱、自由和尊重，这些人必然就会发挥最大的价值。

乔布斯曾经说过，A类工程师招聘A类工程师，B类工程师只能招聘C类工程师。之所以这么说，是因为A类工程师有足够的能力来正确地辨别A、B、C类工程师，有足够的自信去接纳跟自己一样优秀、甚至更加优秀的人才。所以，为了严把人才入口，我们一定要让公司内最优秀的工程师来负责招聘。

当然，并不是每个公司都可以像Google这样，有足够的背景去吸引最优秀的工程师、有足够的投入去招聘最优秀的工程师。但是，我们仍然可以招聘一小撮足够优秀的工程师，让这小部分工程师影响公司里更多的人，带动起我们想要的工程师文化。这就好比，打造一个全是尖子生的尖子班很难，但我们可以在班级里找几个学习榜样，让这一小撮榜样带动起整个班级的学习氛围。

除了在招聘上下功夫，在人才培养上，我们要尽可能留住最符合公司工程师文化的员工，让他们在公司内部有好的职场发展，避免劣币驱逐良币。比如，我们的工程师文化是“马屁文化”，如果你是领导，就要让经常拍你马屁的人升职加薪，慢慢地其他人就会效仿，不接受的人就会离职，“马屁文化”就逐渐形成了。

实际上，我们也不一定非得追求将公司的工程师文化，打造成像Google的一样，毕竟每个公司都有自己的特点，都有自己的发展阶段，完全照抄也不现实。我个人觉得，相对于外企来说，国内企业中跟“人”相关的文化，普遍做得不是太让人满意，比如，以人为本，以结果为导向，讨论就事论事，奖惩公开透明，不搞上下级关系等等，先把这些跟”人“相关的文化搞好，跟”技术“相关的文化，比如重视代码质量、工匠精神、追求效率等等，搞起来就相对容易多了。

## 课堂讨论

聊一聊你最喜欢的工程师文化是什么样子的？最讨厌的工程师文化是什么样子的？

欢迎留言和我分享你的想法。如果有收获，也欢迎你把这篇文章分享给你的朋友。
    